<?php

namespace WpifyWooDeps\GuzzleHttp\Promise;

final class Is
{
    /**
     * Returns true if a promise is pending.
     *
     * @return bool
     */
    public static function pending(\WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface $promise)
    {
        return $promise->getState() === \WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface::PENDING;
    }
    /**
     * Returns true if a promise is fulfilled or rejected.
     *
     * @return bool
     */
    public static function settled(\WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface $promise)
    {
        return $promise->getState() !== \WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface::PENDING;
    }
    /**
     * Returns true if a promise is fulfilled.
     *
     * @return bool
     */
    public static function fulfilled(\WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface $promise)
    {
        return $promise->getState() === \WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface::FULFILLED;
    }
    /**
     * Returns true if a promise is rejected.
     *
     * @return bool
     */
    public static function rejected(\WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface $promise)
    {
        return $promise->getState() === \WpifyWooDeps\GuzzleHttp\Promise\PromiseInterface::REJECTED;
    }
}
