<?php

namespace WpifyWooDeps\h4kuna\DataType\Immutable;

use WpifyWooDeps\h4kuna\DataType;
class Messenger implements \ArrayAccess, \Iterator, \Serializable, \JsonSerializable, \Countable
{
    /** @var array */
    private $data;
    public function __construct(array $data)
    {
        $this->data = $data;
    }
    public final function __get($name)
    {
        return $this->data[$name];
    }
    public final function __isset($name)
    {
        return isset($this->data[$name]);
    }
    public final function __unset($name)
    {
        throw new \WpifyWooDeps\h4kuna\DataType\LogicException('Use "$cloneMessenger = $messenger->remove($key)" instand of "unset($messenger->key)".');
    }
    public final function __set($name, $value)
    {
        throw new \WpifyWooDeps\h4kuna\DataType\LogicException('Use "$cloneMessenger = $messenger->add($key, $value)" instand of "$messenger->key = \'foo\';".');
    }
    public final function add($key, $value)
    {
        $data = $this->data;
        $data[$key] = $value;
        return new static($data);
    }
    public final function exists($key)
    {
        return \array_key_exists($key, $this->data);
    }
    public final function remove(...$key)
    {
        $data = $this->data;
        foreach ($key as $k) {
            unset($data[$k]);
        }
        return new static($data);
    }
    public final function get($key, $default = null)
    {
        if ($this->offsetExists($key)) {
            return $this->offsetGet($key);
        }
        return $default;
    }
    public final function getData()
    {
        return $this->data;
    }
    public final function current()
    {
        return \current($this->data);
    }
    public final function next()
    {
        \next($this->data);
    }
    public final function key()
    {
        return \key($this->data);
    }
    public final function valid()
    {
        return $this->key() !== null;
    }
    public final function rewind()
    {
        \reset($this->data);
    }
    public final function offsetGet($offset)
    {
        return $this->data[$offset];
    }
    public final function offsetSet($offset, $value)
    {
        $this->__set($offset, $value);
    }
    public final function offsetUnset($offset)
    {
        $this->__unset($offset);
    }
    public final function offsetExists($offset)
    {
        return $this->__isset($offset, $this->data);
    }
    public final function serialize()
    {
        return \serialize($this->data);
    }
    public final function unserialize($serialized)
    {
        $this->data = \unserialize($serialized);
    }
    public final function count()
    {
        return \count($this->data);
    }
    public function jsonSerialize()
    {
        return $this->data;
    }
}
