<?php

namespace WpifyWooDeps\Heureka\ShopCertification;

use WpifyWooDeps\Heureka\ShopCertification;
/**
 * @author Jakub Chábek <jakub.chabek@heureka.cz>
 */
class ApiEndpoint
{
    const API_ENDPOINT_CZ = 'https://api.heureka.cz/shop-certification/v2/';
    const API_ENDPOINT_SK = 'https://api.heureka.sk/shop-certification/v2/';
    private static $knownServices = [\WpifyWooDeps\Heureka\ShopCertification::HEUREKA_CZ, \WpifyWooDeps\Heureka\ShopCertification::HEUREKA_SK];
    /**
     * @var int
     */
    private $service;
    /**
     * @param int $service
     *
     * @throws UnknownServiceException
     */
    public function __construct($service)
    {
        if (!\in_array($service, self::$knownServices)) {
            throw new \WpifyWooDeps\Heureka\ShopCertification\UnknownServiceException();
        }
        $this->service = $service;
    }
    /**
     * @return string
     */
    public function getUrl()
    {
        if ($this->service === \WpifyWooDeps\Heureka\ShopCertification::HEUREKA_CZ) {
            return self::API_ENDPOINT_CZ;
        }
        return $endpoint = self::API_ENDPOINT_SK;
    }
}
class UnknownServiceException extends \WpifyWooDeps\Heureka\ShopCertification\Exception
{
}
