<?php

/* ===========================================================================
 * Copyright (c) 2018-2021 Zindex Software
 *
 * Licensed under the MIT License
 * =========================================================================== */
namespace WpifyWooDeps\Opis\Closure;

/**
 * Serialize
 *
 * @param mixed $data
 * @return string
 */
function serialize($data)
{
    \WpifyWooDeps\Opis\Closure\SerializableClosure::enterContext();
    \WpifyWooDeps\Opis\Closure\SerializableClosure::wrapClosures($data);
    $data = \serialize($data);
    \WpifyWooDeps\Opis\Closure\SerializableClosure::exitContext();
    return $data;
}
/**
 * Unserialize
 *
 * @param string $data
 * @param array|null $options
 * @return mixed
 */
function unserialize($data, array $options = null)
{
    \WpifyWooDeps\Opis\Closure\SerializableClosure::enterContext();
    $data = $options === null || \PHP_MAJOR_VERSION < 7 ? \unserialize($data) : \unserialize($data, $options);
    \WpifyWooDeps\Opis\Closure\SerializableClosure::unwrapClosures($data);
    \WpifyWooDeps\Opis\Closure\SerializableClosure::exitContext();
    return $data;
}
