<?php

declare (strict_types=1);
namespace WpifyWooDeps\DI\Definition;

use WpifyWooDeps\DI\Definition\Exception\InvalidDefinition;
/**
 * Extends an array definition by adding new elements into it.
 *
 * @since 5.0
 * @author Matthieu Napoli <matthieu@mnapoli.fr>
 */
class ArrayDefinitionExtension extends \WpifyWooDeps\DI\Definition\ArrayDefinition implements \WpifyWooDeps\DI\Definition\ExtendsPreviousDefinition
{
    /**
     * @var ArrayDefinition
     */
    private $subDefinition;
    public function getValues() : array
    {
        if (!$this->subDefinition) {
            return parent::getValues();
        }
        return \array_merge($this->subDefinition->getValues(), parent::getValues());
    }
    public function setExtendedDefinition(\WpifyWooDeps\DI\Definition\Definition $definition)
    {
        if (!$definition instanceof \WpifyWooDeps\DI\Definition\ArrayDefinition) {
            throw new \WpifyWooDeps\DI\Definition\Exception\InvalidDefinition(\sprintf('Definition %s tries to add array entries but the previous definition is not an array', $this->getName()));
        }
        $this->subDefinition = $definition;
    }
}
