<?php

declare (strict_types=1);
namespace WpifyWooDeps\DI\Definition;

use WpifyWooDeps\Psr\Container\ContainerInterface;
/**
 * Describes a definition that can resolve itself.
 *
 * @author Matthieu Napoli <matthieu@mnapoli.fr>
 */
interface SelfResolvingDefinition
{
    /**
     * Resolve the definition and return the resulting value.
     *
     * @return mixed
     */
    public function resolve(\WpifyWooDeps\Psr\Container\ContainerInterface $container);
    /**
     * Check if a definition can be resolved.
     */
    public function isResolvable(\WpifyWooDeps\Psr\Container\ContainerInterface $container) : bool;
}
