<?php

namespace WpifyWoo\PacketeraSDK\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Create ServiceType
 * @subpackage Services
 */
class Create extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named createPacket
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketAttributes $attributes
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketIdDetail|bool
     */
    public function createPacket($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketAttributes $attributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('createPacket', array(
                $apiPassword,
                $attributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createPackets
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketsAttributes $packets
     * @param string $transaction
     * @return \WpifyWoo\PacketeraSDK\StructType\CreatePacketsResults|bool
     */
    public function createPackets($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketsAttributes $packets, $transaction)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('createPackets', array(
                $apiPassword,
                $packets,
                $transaction,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createPacketClaim
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\ClaimAttributes $claimAttributes
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketIdDetail|bool
     */
    public function createPacketClaim($apiPassword, \WpifyWoo\PacketeraSDK\StructType\ClaimAttributes $claimAttributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('createPacketClaim', array(
                $apiPassword,
                $claimAttributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createShipment
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketIds $packetIds
     * @param string $customBarcode
     * @return \WpifyWoo\PacketeraSDK\StructType\ShipmentIdDetail|bool
     */
    public function createShipment($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketIds $packetIds, $customBarcode)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('createShipment', array(
                $apiPassword,
                $packetIds,
                $customBarcode,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named createPacketLiftago
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketLiftagoAttributes $attributes
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketIdDetail|bool
     */
    public function createPacketLiftago($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketLiftagoAttributes $attributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('createPacketLiftago', array(
                $apiPassword,
                $attributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \WpifyWoo\PacketeraSDK\StructType\CreatePacketsResults|\WpifyWoo\PacketeraSDK\StructType\PacketIdDetail|\WpifyWoo\PacketeraSDK\StructType\ShipmentIdDetail
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
