<?php

namespace WpifyWoo\PacketeraSDK\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named getConsignmentPassword
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketConsignerAttributes $packetConsignerAttributes
     * @return \WpifyWoo\PacketeraSDK\StructType\ConsignmentPasswordResult|bool
     */
    public function getConsignmentPassword($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketConsignerAttributes $packetConsignerAttributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('getConsignmentPassword', array(
                $apiPassword,
                $packetConsignerAttributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \WpifyWoo\PacketeraSDK\StructType\ConsignmentPasswordResult
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
