<?php

namespace WpifyWoo\PacketeraSDK\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Packet ServiceType
 * @subpackage Services
 */
class Packet extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named packetAttributesValid
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketAttributes $attributes
     * @return void|bool
     */
    public function packetAttributesValid($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketAttributes $attributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetAttributesValid', array(
                $apiPassword,
                $attributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetClaimAttributesValid
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\ClaimAttributes $claimAttributes
     * @return void|bool
     */
    public function packetClaimAttributesValid($apiPassword, \WpifyWoo\PacketeraSDK\StructType\ClaimAttributes $claimAttributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetClaimAttributesValid', array(
                $apiPassword,
                $claimAttributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetStatus
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return \WpifyWoo\PacketeraSDK\StructType\CurrentStatusRecord|bool
     */
    public function packetStatus($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetStatus', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetTracking
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return \WpifyWoo\PacketeraSDK\StructType\StatusRecords|bool
     */
    public function packetTracking($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetTracking', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierTracking
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecords|bool
     */
    public function packetCourierTracking($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierTracking', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetGetStoredUntil
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return \WpifyWoo\PacketeraSDK\StructType\NullableDate|bool
     */
    public function packetGetStoredUntil($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetGetStoredUntil', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetSetStoredUntil
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $date
     * @return void|bool
     */
    public function packetSetStoredUntil($apiPassword, $packetId, $date)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetSetStoredUntil', array(
                $apiPassword,
                $packetId,
                $date,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetLabelPdf
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $format
     * @param string $offset
     * @return base64Binary|bool
     */
    public function packetLabelPdf($apiPassword, $packetId, $format, $offset)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetLabelPdf', array(
                $apiPassword,
                $packetId,
                $format,
                $offset,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierNumber
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return string|bool
     */
    public function packetCourierNumber($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierNumber', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierNumberV2
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketCourierNumberV2Result|bool
     */
    public function packetCourierNumberV2($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierNumberV2', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierBarcode
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $courierNumber
     * @return string|bool
     */
    public function packetCourierBarcode($apiPassword, $packetId, $courierNumber)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierBarcode', array(
                $apiPassword,
                $packetId,
                $courierNumber,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierLabelPng
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $courierNumber
     * @return base64Binary|bool
     */
    public function packetCourierLabelPng($apiPassword, $packetId, $courierNumber)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierLabelPng', array(
                $apiPassword,
                $packetId,
                $courierNumber,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierLabelPdf
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $courierNumber
     * @return base64Binary|bool
     */
    public function packetCourierLabelPdf($apiPassword, $packetId, $courierNumber)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierLabelPdf', array(
                $apiPassword,
                $packetId,
                $courierNumber,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierLabelZpl
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $courierNumber
     * @param string $dpi
     * @return string|bool
     */
    public function packetCourierLabelZpl($apiPassword, $packetId, $courierNumber, $dpi)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierLabelZpl', array(
                $apiPassword,
                $packetId,
                $courierNumber,
                $dpi,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCourierConfirm
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param string $courierNumber
     * @return void|bool
     */
    public function packetCourierConfirm($apiPassword, $packetId, $courierNumber)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCourierConfirm', array(
                $apiPassword,
                $packetId,
                $courierNumber,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetCod
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @return money|bool
     */
    public function packetCod($apiPassword, $packetId)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetCod', array(
                $apiPassword,
                $packetId,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return base64Binary|money|string|void|\WpifyWoo\PacketeraSDK\StructType\CurrentStatusRecord|\WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecords|\WpifyWoo\PacketeraSDK\StructType\NullableDate|\WpifyWoo\PacketeraSDK\StructType\PacketCourierNumberV2Result|\WpifyWoo\PacketeraSDK\StructType\StatusRecords
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
