<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomsDeclaration StructType
 * @subpackage Structs
 */
class CustomsDeclaration extends AbstractStructBase
{
    /**
     * The deliveryCostEur
     * Meta information extracted from the WSDL
     * - base: xsd:decimal
     * - fractionDigits: 2
     * @var float
     */
    public $deliveryCostEur;
    /**
     * The deliveryCost
     * Meta information extracted from the WSDL
     * - base: xsd:decimal
     * - fractionDigits: 2
     * @var float
     */
    public $deliveryCost;
    /**
     * The items
     * @var \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItems
     */
    public $items;
    /**
     * Constructor method for CustomsDeclaration
     * @uses CustomsDeclaration::setDeliveryCostEur()
     * @uses CustomsDeclaration::setDeliveryCost()
     * @uses CustomsDeclaration::setItems()
     * @param float $deliveryCostEur
     * @param float $deliveryCost
     * @param \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItems $items
     */
    public function __construct($deliveryCostEur = null, $deliveryCost = null, \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItems $items = null)
    {
        $this
            ->setDeliveryCostEur($deliveryCostEur)
            ->setDeliveryCost($deliveryCost)
            ->setItems($items);
    }
    /**
     * Get deliveryCostEur value
     * @return float|null
     */
    public function getDeliveryCostEur()
    {
        return $this->deliveryCostEur;
    }
    /**
     * Set deliveryCostEur value
     * @param float $deliveryCostEur
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclaration
     */
    public function setDeliveryCostEur($deliveryCostEur = null)
    {
        // validation for constraint: float
        if (!is_null($deliveryCostEur) && !(is_float($deliveryCostEur) || is_numeric($deliveryCostEur))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($deliveryCostEur, true), gettype($deliveryCostEur)), __LINE__);
        }
        // validation for constraint: fractionDigits(2)
        if (!is_null($deliveryCostEur) && mb_strlen(mb_substr($deliveryCostEur, false !== mb_strpos($deliveryCostEur, '.') ? mb_strpos($deliveryCostEur, '.') + 1 : mb_strlen($deliveryCostEur))) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must at most contain 2 fraction digits, %d given', var_export($deliveryCostEur, true), mb_strlen(mb_substr($deliveryCostEur, mb_strpos($deliveryCostEur, '.') + 1))), __LINE__);
        }
        $this->deliveryCostEur = $deliveryCostEur;
        return $this;
    }
    /**
     * Get deliveryCost value
     * @return float|null
     */
    public function getDeliveryCost()
    {
        return $this->deliveryCost;
    }
    /**
     * Set deliveryCost value
     * @param float $deliveryCost
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclaration
     */
    public function setDeliveryCost($deliveryCost = null)
    {
        // validation for constraint: float
        if (!is_null($deliveryCost) && !(is_float($deliveryCost) || is_numeric($deliveryCost))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($deliveryCost, true), gettype($deliveryCost)), __LINE__);
        }
        // validation for constraint: fractionDigits(2)
        if (!is_null($deliveryCost) && mb_strlen(mb_substr($deliveryCost, false !== mb_strpos($deliveryCost, '.') ? mb_strpos($deliveryCost, '.') + 1 : mb_strlen($deliveryCost))) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must at most contain 2 fraction digits, %d given', var_export($deliveryCost, true), mb_strlen(mb_substr($deliveryCost, mb_strpos($deliveryCost, '.') + 1))), __LINE__);
        }
        $this->deliveryCost = $deliveryCost;
        return $this;
    }
    /**
     * Get items value
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItems|null
     */
    public function getItems()
    {
        return $this->items;
    }
    /**
     * Set items value
     * @param \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItems $items
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclaration
     */
    public function setItems(\WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItems $items = null)
    {
        $this->items = $items;
        return $this;
    }
}
