<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for getConsignmentPasswordResult StructType
 * @subpackage Structs
 */
class GetConsignmentPasswordResult extends AbstractStructBase
{
    /**
     * The packetConsignerDetail
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail
     */
    public $packetConsignerDetail;
    /**
     * The fault
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $fault;
    /**
     * The IncorrectApiPasswordFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WpifyWoo\PacketeraSDK\StructType\IncorrectApiPasswordFault
     */
    public $IncorrectApiPasswordFault;
    /**
     * The PacketIdFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WpifyWoo\PacketeraSDK\StructType\PacketIdFault
     */
    public $PacketIdFault;
    /**
     * The AccessDeniedFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WpifyWoo\PacketeraSDK\StructType\AccessDeniedFault
     */
    public $AccessDeniedFault;
    /**
     * The PacketAttributesFault
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \WpifyWoo\PacketeraSDK\StructType\PacketAttributesFault
     */
    public $PacketAttributesFault;
    /**
     * Constructor method for getConsignmentPasswordResult
     * @uses GetConsignmentPasswordResult::setPacketConsignerDetail()
     * @uses GetConsignmentPasswordResult::setFault()
     * @uses GetConsignmentPasswordResult::setIncorrectApiPasswordFault()
     * @uses GetConsignmentPasswordResult::setPacketIdFault()
     * @uses GetConsignmentPasswordResult::setAccessDeniedFault()
     * @uses GetConsignmentPasswordResult::setPacketAttributesFault()
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail $packetConsignerDetail
     * @param string $fault
     * @param \WpifyWoo\PacketeraSDK\StructType\IncorrectApiPasswordFault $incorrectApiPasswordFault
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketIdFault $packetIdFault
     * @param \WpifyWoo\PacketeraSDK\StructType\AccessDeniedFault $accessDeniedFault
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketAttributesFault $packetAttributesFault
     */
    public function __construct(\WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail $packetConsignerDetail = null, $fault = null, \WpifyWoo\PacketeraSDK\StructType\IncorrectApiPasswordFault $incorrectApiPasswordFault = null, \WpifyWoo\PacketeraSDK\StructType\PacketIdFault $packetIdFault = null, \WpifyWoo\PacketeraSDK\StructType\AccessDeniedFault $accessDeniedFault = null, \WpifyWoo\PacketeraSDK\StructType\PacketAttributesFault $packetAttributesFault = null)
    {
        $this
            ->setPacketConsignerDetail($packetConsignerDetail)
            ->setFault($fault)
            ->setIncorrectApiPasswordFault($incorrectApiPasswordFault)
            ->setPacketIdFault($packetIdFault)
            ->setAccessDeniedFault($accessDeniedFault)
            ->setPacketAttributesFault($packetAttributesFault);
    }
    /**
     * Get packetConsignerDetail value
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail|null
     */
    public function getPacketConsignerDetail()
    {
        return $this->packetConsignerDetail;
    }
    /**
     * Set packetConsignerDetail value
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail $packetConsignerDetail
     * @return \WpifyWoo\PacketeraSDK\StructType\GetConsignmentPasswordResult
     */
    public function setPacketConsignerDetail(\WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail $packetConsignerDetail = null)
    {
        $this->packetConsignerDetail = $packetConsignerDetail;
        return $this;
    }
    /**
     * Get fault value
     * @return string|null
     */
    public function getFault()
    {
        return $this->fault;
    }
    /**
     * Set fault value
     * @param string $fault
     * @return \WpifyWoo\PacketeraSDK\StructType\GetConsignmentPasswordResult
     */
    public function setFault($fault = null)
    {
        // validation for constraint: string
        if (!is_null($fault) && !is_string($fault)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fault, true), gettype($fault)), __LINE__);
        }
        $this->fault = $fault;
        return $this;
    }
    /**
     * Get IncorrectApiPasswordFault value
     * @return \WpifyWoo\PacketeraSDK\StructType\IncorrectApiPasswordFault|null
     */
    public function getIncorrectApiPasswordFault()
    {
        return $this->IncorrectApiPasswordFault;
    }
    /**
     * Set IncorrectApiPasswordFault value
     * @param \WpifyWoo\PacketeraSDK\StructType\IncorrectApiPasswordFault $incorrectApiPasswordFault
     * @return \WpifyWoo\PacketeraSDK\StructType\GetConsignmentPasswordResult
     */
    public function setIncorrectApiPasswordFault(\WpifyWoo\PacketeraSDK\StructType\IncorrectApiPasswordFault $incorrectApiPasswordFault = null)
    {
        $this->IncorrectApiPasswordFault = $incorrectApiPasswordFault;
        return $this;
    }
    /**
     * Get PacketIdFault value
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketIdFault|null
     */
    public function getPacketIdFault()
    {
        return $this->PacketIdFault;
    }
    /**
     * Set PacketIdFault value
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketIdFault $packetIdFault
     * @return \WpifyWoo\PacketeraSDK\StructType\GetConsignmentPasswordResult
     */
    public function setPacketIdFault(\WpifyWoo\PacketeraSDK\StructType\PacketIdFault $packetIdFault = null)
    {
        $this->PacketIdFault = $packetIdFault;
        return $this;
    }
    /**
     * Get AccessDeniedFault value
     * @return \WpifyWoo\PacketeraSDK\StructType\AccessDeniedFault|null
     */
    public function getAccessDeniedFault()
    {
        return $this->AccessDeniedFault;
    }
    /**
     * Set AccessDeniedFault value
     * @param \WpifyWoo\PacketeraSDK\StructType\AccessDeniedFault $accessDeniedFault
     * @return \WpifyWoo\PacketeraSDK\StructType\GetConsignmentPasswordResult
     */
    public function setAccessDeniedFault(\WpifyWoo\PacketeraSDK\StructType\AccessDeniedFault $accessDeniedFault = null)
    {
        $this->AccessDeniedFault = $accessDeniedFault;
        return $this;
    }
    /**
     * Get PacketAttributesFault value
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketAttributesFault|null
     */
    public function getPacketAttributesFault()
    {
        return $this->PacketAttributesFault;
    }
    /**
     * Set PacketAttributesFault value
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketAttributesFault $packetAttributesFault
     * @return \WpifyWoo\PacketeraSDK\StructType\GetConsignmentPasswordResult
     */
    public function setPacketAttributesFault(\WpifyWoo\PacketeraSDK\StructType\PacketAttributesFault $packetAttributesFault = null)
    {
        $this->PacketAttributesFault = $packetAttributesFault;
        return $this;
    }
}
