<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PacketConsignerDetail StructType
 * @subpackage Structs
 */
class PacketConsignerDetail extends AbstractStructBase
{
    /**
     * The id
     * @var string
     */
    public $id;
    /**
     * The password
     * @var string
     */
    public $password;
    /**
     * The consignerEmail
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - pattern: |.*@.*\..*
     * @var string
     */
    public $consignerEmail;
    /**
     * The consignerPhone
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - nillable: true
     * - pattern: \s*(\+?42[01])?\s*[0-9]{3}\s*[0-9]{3}\s*[0-9]{3}\s*
     * @var string
     */
    public $consignerPhone;
    /**
     * The consignerCountry
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - length: 2
     * - nillable: true
     * @var string
     */
    public $consignerCountry;
    /**
     * Constructor method for PacketConsignerDetail
     * @uses PacketConsignerDetail::setId()
     * @uses PacketConsignerDetail::setPassword()
     * @uses PacketConsignerDetail::setConsignerEmail()
     * @uses PacketConsignerDetail::setConsignerPhone()
     * @uses PacketConsignerDetail::setConsignerCountry()
     * @param string $id
     * @param string $password
     * @param string $consignerEmail
     * @param string $consignerPhone
     * @param string $consignerCountry
     */
    public function __construct($id = null, $password = null, $consignerEmail = null, $consignerPhone = null, $consignerCountry = null)
    {
        $this
            ->setId($id)
            ->setPassword($password)
            ->setConsignerEmail($consignerEmail)
            ->setConsignerPhone($consignerPhone)
            ->setConsignerCountry($consignerCountry);
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get consignerEmail value
     * @return string|null
     */
    public function getConsignerEmail()
    {
        return $this->consignerEmail;
    }
    /**
     * Set consignerEmail value
     * @param string $consignerEmail
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail
     */
    public function setConsignerEmail($consignerEmail = null)
    {
        // validation for constraint: string
        if (!is_null($consignerEmail) && !is_string($consignerEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($consignerEmail, true), gettype($consignerEmail)), __LINE__);
        }
        // validation for constraint: pattern(|.*@.*\..*)
        if (!is_null($consignerEmail) && !preg_match('/|.*@.*\\..*/', $consignerEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression /|.*@.*\\..*/', var_export($consignerEmail, true)), __LINE__);
        }
        $this->consignerEmail = $consignerEmail;
        return $this;
    }
    /**
     * Get consignerPhone value
     * @return string|null
     */
    public function getConsignerPhone()
    {
        return $this->consignerPhone;
    }
    /**
     * Set consignerPhone value
     * @param string $consignerPhone
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail
     */
    public function setConsignerPhone($consignerPhone = null)
    {
        // validation for constraint: string
        if (!is_null($consignerPhone) && !is_string($consignerPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($consignerPhone, true), gettype($consignerPhone)), __LINE__);
        }
        // validation for constraint: pattern(\s*(\+?42[01])?\s*[0-9]{3}\s*[0-9]{3}\s*[0-9]{3}\s*)
        if (!is_null($consignerPhone) && !preg_match('/\\s*(\\+?42[01])?\\s*[0-9]{3}\\s*[0-9]{3}\\s*[0-9]{3}\\s*/', $consignerPhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a literal that is among the set of character sequences denoted by the regular expression /\\s*(\\+?42[01])?\\s*[0-9]{3}\\s*[0-9]{3}\\s*[0-9]{3}\\s*/', var_export($consignerPhone, true)), __LINE__);
        }
        $this->consignerPhone = $consignerPhone;
        return $this;
    }
    /**
     * Get consignerCountry value
     * @return string|null
     */
    public function getConsignerCountry()
    {
        return $this->consignerCountry;
    }
    /**
     * Set consignerCountry value
     * @param string $consignerCountry
     * @return \WpifyWoo\PacketeraSDK\StructType\PacketConsignerDetail
     */
    public function setConsignerCountry($consignerCountry = null)
    {
        // validation for constraint: string
        if (!is_null($consignerCountry) && !is_string($consignerCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($consignerCountry, true), gettype($consignerCountry)), __LINE__);
        }
        // validation for constraint: length(2)
        if (!is_null($consignerCountry) && mb_strlen($consignerCountry) !== 2) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be equal to 2', mb_strlen($consignerCountry)), __LINE__);
        }
        $this->consignerCountry = $consignerCountry;
        return $this;
    }
}
