import $ from 'jquery';

const checkbox = document.querySelector('#company_details');

const updateIcDicFields = () => {
	const country = document.querySelector('#billing_country');
	const autofill = document.querySelector('#wpify-woo-ares-autofill');
	const dicDph = document.querySelector('#billing_dic_dph_field');

	if (autofill) {
		if (country && country.value === 'CZ') {
			autofill.style.display = 'block';
		} else {
			autofill.style.display = 'none';
		}

		if (country && country.value !== 'SK') {
			dicDph.style.display = 'none';
		} else if (checkbox.checked) {
			dicDph.style.display = 'block';
		}
	}
};

if (checkbox) {
	let fields = Array.from(document.getElementsByClassName('wpify-woo-ic-dic__company_field'));

	checkbox.addEventListener('change', (event) => {
		if (event.target.checked) {
			showFields();
		} else {
			fields.forEach((item) => item.style.display = 'none');
		}
	});
}

const showFields = () => {
	const fields = Array.from(document.getElementsByClassName('wpify-woo-ic-dic__company_field'));
	const country = document.querySelector('#billing_country')
		? document.querySelector('#billing_country').value
		: null;

	fields.forEach((item) => {
		console.log(item.id, country);

		if (item.id === 'billing_dic_dph_field' && country !== 'SK') {
			item.style.display = 'none';
		} else {
			item.style.display = 'block';
		}
	});
};

const aresShowBtn = document.getElementById('wpify-woo-icdic__ares-autofill-button');

if (aresShowBtn) {
	aresShowBtn.addEventListener('click', function (e) {
		e.preventDefault();
		document.getElementsByClassName('wpify-woo-icdic__ares-autofill')[0].style.display = 'block';
	});
}

const aresBtn = document.getElementById('wpify-woo-icdic__ares-submit');

if (aresBtn) {
	aresBtn.addEventListener('click', function () {
		const ino = document.getElementById('ares_in').value;
		return fetch(`${wpifyWooIcDic.restUrl}/icdic?in=${ino}`)
			.then(res => {
				if (!res.ok) {
					return res.json().then(json => {
						document.getElementById('wpify-woo-icdic__ares-result').innerHTML = json.message;
					});
				}

				res.json().then(json => {
					const details = json.details;

					Object.keys(details).forEach(function (key) {
						const element = document.getElementById(key);

						if (element) {
							element.value = details[key];
						}
					});

					const checkbox = document.getElementById('company_details');

					if (checkbox) {
						checkbox.checked = true;
					}

					document.getElementsByClassName('wpify-woo-icdic__ares-autofill')[0].style.display = 'none';

					showFields();
				});
			})
			.catch(err => {

			});
	});
}

const removeIcErrorMessage = () => {
	Array.from(document.querySelectorAll('.wpify-woo__ic-error')).forEach(function (item) {
		item.parentNode.removeChild(item);
	});
};

if (document.getElementsByClassName('wpify-woo-ic--validate').length) {
	const icField = document.getElementById('billing_ic');

	icField.addEventListener('change', function () {
		if (!icField.value) {
			removeIcErrorMessage();
			return false;
		}

		return fetch(`${wpifyWooIcDic.restUrl}/icdic?in=${icField.value}`)
			.then(res => {
				if (!res.ok) {
					return res.json().then(json => {
						const el = document.createElement('div');
						el.innerHTML = json.message;
						el.classList.add('wpify-woo__ic-error');
						icField.parentNode.insertBefore(el, icField.nextSibling);
						document.getElementById('wpify-woo-icdic__ares-result').innerHTML = json.message;
					});
				}

				res.json().then(json => {
					removeIcErrorMessage();
					document.getElementById('billing_dic').value = json.details.billing_dic;
					document.getElementById('billing_company').value = json.details.billing_company;
				});
			})
			.catch(err => {

			});
	});
}

document.querySelectorAll('#billing_dic,#company_details').forEach((input) => {
	const refresh = () => jQuery(document.body).trigger('update_checkout');
	input.addEventListener('change', refresh);
});

$(document.body).on('updated_checkout', updateIcDicFields);
