<?php

namespace WpifyWoo\Modules\PacketaShipping;

use WC_Shipping_Flat_Rate;

if ( ! class_exists( PacketaShippingMethod::class ) ) {
	class PacketaShippingMethod extends WC_Shipping_Flat_Rate {
		/**
		 * Constructor.
		 *
		 * @param int $instance_id Shipping method instance ID.
		 */
		public function __construct( $instance_id = 0 ) {
			$this->id           = 'packeta';
			$this->instance_id  = absint( $instance_id );
			$this->method_title = __( 'Packeta', 'wpify-woo' );
			$this->supports     = array(
				'shipping-zones',
				'instance-settings',
				'instance-settings-modal',
			);

			$this->init();

			add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
		}
	}

}
